--called by main
-------------------------------
function create_document()
-------------------------------
   
  local song = renoise.song()
  
  --NOTES:
  --------
  --list/node/list/node (??not lists to lists??)
  --Nodes can be added to lists
  --lists can be added to nodes
  
  -------
  --lists
  --------
  --list as "value" to be added into main doc 
  local plugin_type_list = renoise.Document.DocumentList()
  local page_list = renoise.Document.DocumentList()
  local tag_list = renoise.Document.DocumentList()
  local plug_list = renoise.Document.DocumentList()

  ----------------------
  --create main doc/root
  ----------------------
  root = renoise.Document.create("TaggedPluginsTool") {   
    plugin_types = plugin_type_list,
    --name = NUL,
   }
   
   --> root.plugin_types[]
  
  --------------------
  --define node models 
  --------------------
  
  --level 1 node model
  --------------------
  renoise.Document.create("PluginType") {
    name = NUL,
    pages = page_list, --creates type(doc_list), empty at moment in declaration but will be defined below
   } 
   
   --> root.plugin_types[].pages[]
  
  --level 2 node model
  --------------------
  renoise.Document.create("Page") {
    tags = tag_list, --creates tag(doc_list), empty at moment in declaration but will be defined below
    name = NUL
   }
   
   --> root.plugin_types[].pages[].tags[]
   --> root.plugin_types[].pages[].name.value
  
  --level 3 node model
  --------------------
  renoise.Document.create("Tag") {
    plugs = plug_list,
    name = NUL,
    number = NUL,
   }
   
   --> root.plugin_types[].pages[].tags[].plugs[]
   --> root.plugin_types[].pages[].tags[].name.value
 
  --level 4 node model (MOST NESTED)
  ----------------------------------
  renoise.Document.create("Plugin") { --model name registration
     plug_name = "",
     plug_path = "",
   }
   
   --> root.plugin_types[].pages[].tags[].plugs[].plug_name.value
   --> root.plugin_types[].pages[].tags[].plugs[].plug_path.value
   
  -----------------------------------
  
  --Populate empty lists with nodes to create structure
  -----------------------------------------------------
  --instantiate models:
  --IMPORTANT! NEEDS TO BE DONE REVERSE ORDER: 'most nested' node first (--??)
  ----------------------------------------------------------------------  
  
  --4) NOT NEEDED AS PLUGS ARE ADDED BY FUNCTION LATER WHICH DOES INSTANTIATION + INSERTION ITSELF
  --4) instantiate "Plugin" then add as node :
  ----------------------------------------
  --local my_plugin = renoise.Document.instantiate("Plugin")
  --insert "Plugin" doc node, into plug_list object "List":
  --plug_list:insert(my_plugin)
  ---------------------------------
  
  --3) Instantiate and insert insert 12 tags per page
  ------------------------------------------------
  for i = 1,12 do
    --instantiate "Tag"node model
    local my_tag = renoise.Document.instantiate("Tag")   
    tag_list:insert(my_tag)
  end
     
  --2) instantiate "Page"s then add as nodes in page_list so we get <Page><Tag><Plugin>
  ------------------------------------------------
  local my_page = renoise.Document.instantiate("Page")
  local my_page2 = renoise.Document.instantiate("Page")
  local my_page3 = renoise.Document.instantiate("Page")
  --insert 
  page_list:insert(my_page)
  page_list:insert(my_page2)
  page_list:insert(my_page3)
  
  --1) instantiate type, [1] will be instruments and [2] effects
  --------------------------------------------------------------
  local my_type = renoise.Document.instantiate("PluginType")
  local my_type_2 = renoise.Document.instantiate("PluginType")
  
  plugin_type_list:insert(my_type)
  plugin_type_list:insert(my_type_2)
  -----
  
  --print(#root.plugin_types)

  --put in values
  -----------------------
  --1) default instrument
  -----------------------
  local inst = root.plugin_types[1]
  ------------------------------------------------------
  --set the default page names (REMEMBER to use '.value')
  -------------------------------------------------------
  inst.pages[1].name.value = "Page 1"
  inst.pages[2].name.value = "Page 2"
  inst.pages[3].name.value = "Page 3"
  
  --set the tag numbers for instruments
  --------------------------------------
  for page = 1,3 do
    for tag = 1,12 do
      inst.pages[page].tags[tag].number.value = tostring(tag)
    end
  end
  
  --set the default tag names ---------------------------(TODO use vars for efficiency i.e. local pge =)
  ---------------------------
  for page = 1,3 do
    for tag = 1,12 do
      inst.pages[page].tags[tag].name.value = tostring(tag) --"Tag "..tag
    end
  end
  
  ---------------
  --2) default fx
  ---------------
  local fx = root.plugin_types[2]
  ------------------------------------------------------
  --set the default page names (REMEMBER to use '.value')
  -------------------------------------------------------
  fx.pages[1].name.value = "Page 1"
  fx.pages[2].name.value = "Page 2"
  fx.pages[3].name.value = "Page 3"
  
  --set the tag numbers for fx
  ----------------------------
  for page = 1,3 do
    for tag = 1,12 do
      fx.pages[page].tags[tag].number.value = tostring(tag)
    end
  end
  
  --set the default tag names ------------------------------(TODO use vars for efficiency i.e. local pge =)
  ---------------------------
  for page = 1,3 do
    for tag = 1,12 do
      fx.pages[page].tags[tag].name.value = tostring(tag) --"Tag "..tag
    end
  end
  
  --set type names as Instrument or FX
  --------------------------------------
  inst.name.value = "Instrument"
  fx.name.value = "Effect"
    
  --sort nodes alphabetically??
  
  
  -----------------
  --Document object
  -----------------
  return root

end

  
--DEFAULT XML CONTENT
--function adds default renoise fx devices into a newly created default xml
--requires global `root`
-----------------------------------------------------------------
function popuplate_page_one_of_xml_with_default_renoise_devices()
-----------------------------------------------------------------

  --------------------------------------------
  --Create renoise document and call it 'UserTagLists'
  ----------------------------------------------------
  --pageX: has all the information for a page of tags in the gui (native/user 1/user 2)
  --tagX is an individual tag
  --the string list contains 3 entries for each plug, the tag name, the plugs display name and the loading path.

 -- local inst = root.plugin_types[1]
  local fx = root.plugin_types[2]
  local page_1 = fx.pages[1]
  
  --default tag names 
  page_1.tags[1].name.value = "Comp / Lim"
  page_1.tags[2].name.value = "Delay"
  page_1.tags[3].name.value = "Distortion"
  page_1.tags[4].name.value = "EQ"
  page_1.tags[5].name.value = "Filter"
  page_1.tags[6].name.value = "Gate"
  page_1.tags[7].name.value = "Modulation"
  page_1.tags[8].name.value = "Reverb"
  page_1.tags[9].name.value = "Saturation"
  page_1.tags[10].name.value = "Utility"
  page_1.tags[11].name.value = "*Meta"
  page_1.tags[12].name.value = "#Routing"
  
  --default devices
  --insert native plugs to their relevant tags 
  --odd entries will be plug names, even entries will be the path for the preceding plug
  
  --tag 1 Dynamics
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_1,"Bus Compressor","Audio/Effects/Native/Bus Compressor")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_1,"Compressor","Audio/Effects/Native/Compressor")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_1,"Maximizer","Audio/Effects/Native/Maximizer")
  --tag 2 Delay
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_2,"Delay","Audio/Effects/Native/Delay")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_2,"Multitap Delay","Audio/Effects/Native/Multitap")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_2,"Repeater","Audio/Effects/Native/Repeater")
  --tag 3 Distortion
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_3,"Cabinet Simulator","Audio/Effects/Native/Cabinet Simulator")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_3,"Distortion","Audio/Effects/Native/Distortion 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_3,"LofiMat","Audio/Effects/Native/LofiMat 2")
  --tag 4 EQ
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_4,"EQ 5","Audio/Effects/Native/EQ 5")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_4,"EQ 10","Audio/Effects/Native/EQ 10")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_4,"Mixer EQ","Audio/Effects/Native/Mixer EQ")
  --tag 5 Filter
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_5,"Analog Filter","Audio/Effects/Native/Analog Filter")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_5,"Comb Filter","Audio/Effects/Native/Comb Filter 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_5,"Digital Filter","Audio/Effects/Native/Digital Filter")
  --tag 6 Gate
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_6,"Gate","Audio/Effects/Native/Gate 2")
  --tag 7 Modulation
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_7,"Chorus","Audio/Effects/Native/Chorus 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_7,"Flanger","Audio/Effects/Native/Flanger 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_7,"Phaser","Audio/Effects/Native/Phaser 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_7,"RingMod","Audio/Effects/Native/RingMod 2")
  --tag 8 reverb
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_8,"Convolver","Audio/Effects/Native/Convolver")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_8,"mpReverb","Audio/Effects/Native/mpReverb 2")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_8,"Reverb","Audio/Effects/Native/Reverb") 
  --tag 9 Saturation
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_9,"Exciter","Audio/Effects/Native/Exciter")
  --tag 10 Utility
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_10,"DC Offset","Audio/Effects/Native/DC Offset")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_10,"Doofer","Audio/Effects/Native/Doofer")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_10,"Gainer","Audio/Effects/Native/Gainer")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_10,"Stereo Expander","Audio/Effects/Native/Stereo Expander")
  --tag 11 Meta
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Formula","Audio/Effects/Native/*Formula")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Hydra","Audio/Effects/Native/*Hydra")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Instr. Automation","Audio/Effects/Native/*Instr. Automation")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Instr. Macros","Audio/Effects/Native/*Instr. Macros")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Instr. MIDI Control","Audio/Effects/Native/*Instr. MIDI Control")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Key Tracker","Audio/Effects/Native/*Key Tracker")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*LFO","Audio/Effects/Native/*LFO")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Meta Mixer","Audio/Effects/Native/*Meta Mixer")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Signal Follower","Audio/Effects/Native/*Signal Follower")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*Velocity Tracker","Audio/Effects/Native/*Velocity Tracker")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_11,"*XY Pad","Audio/Effects/Native/*XY Pad")
  --Tag 12 #Routing
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_12,"#Line Input","Audio/Effects/Native/#Line Input")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_12,"#Multiband Send","Audio/Effects/Native/#Multiband Send")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_12,"#ReWire Input","Audio/Effects/Native/#ReWire Input")
  insert_new_plugin_node(TYPE_EFFECT,PAGE_1,TAG_12,"#Send","Audio/Effects/Native/#Send")   
end
---






