--edit_tag_names_gui.lua <<<this file


------------------
--Quick Reference:
------------------
--1) Basic format of g_retrieved_xml object:
--------------------------------------------
--g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value

--decalre fx pages[] node
--local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages


my_vb1_dialog = nil
vb1 = nil

------------------------------
function edit_tag_names_gui(vb)--pass in vb (main gui object reference)
------------------------------
  --GUI HOUSEKEEPING
  --toggle dialog so if its already open then close it.
  if (my_vb1_dialog and my_vb1_dialog.visible) then 
    my_vb1_dialog:close()
    my_vb1_dialog = nil
    vb1 = nil
    return
  end
  
  
  --TODO
  --update page name
  --update names in xml when edited
  
  -----------------------------------
  local function get_all_tag_names(page_idx)
  -----------------------------------
    --table to return with tag names
    local tag_names_table = {}

    local fx_pages = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
    --loop all tags
    for tag = 1,#fx_pages[page_idx].tags do 
      tag_names_table[tag] = tostring(fx_pages[page_idx].tags[tag].name.value) --use tostring as we are reading string objects
    end
    return tag_names_table
  end
  
  
  

  --update the 'main()' gui so that page2 (user 1) is selected
  --(Native page1 can not be modified with 'this' gui)
  --------------------------------------------
  local function choose_page_in_main_gui(page)
  --------------------------------------------
    --set global page variable to chosen page
    g_selected_page = page
    
    --xml object format = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value
    --fx page node
    local fx_pages = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
    
    if page == 2 then
      --update page button colors
      vb.views["page1"].color = COLOR_GREY
      vb.views["page2"].color = COLOR_YELLOW_MILD
      vb.views["page3"].color = COLOR_GREY
      
      
      --update tag buttons and popup
      for button = 1,12 do
        --get each tag names for page 2 from the xml 
        local tag = tostring(fx_pages[2].tags[button].name.value)
        vb.views["tag "..tostring(button)].text = tag
      end
    elseif page == 3 then
      g_selected_page = 3
      --update page button colors
      vb.views["page1"].color = COLOR_GREY
      vb.views["page2"].color = COLOR_GREY
      vb.views["page3"].color = COLOR_YELLOW_MILD
      
      --update tag buttons and popup
      for button = 1,12 do
        --get each tag names for page 2 from the xml 
        local tag = tostring(fx_pages[3].tags[button].name.value)
        vb.views["tag "..tostring(button)].text = tag
      end
    end
    
    end
   -------------------------------------------
   --run
   if g_selected_page ==1 then
     choose_page_in_main_gui(2)  
   end
                                    
  

  
  

  --Build 'this GUI'
  ------------------
  --make a new viewbuilder instance vb1 (vb is the main gui)
  vb1 = renoise.ViewBuilder()

  --create the tags column with a loop first (lower 12 tagedit (names) textfields)
  --to be added in later.
  local tags_col = vb1:row{}
  local tags_col_2 = vb1:row{}
  
  for counter = 1,12 do
    --1 button
    local tags  = vb1:textfield { 
                width = 92,
                height = 28,
                text = "",
                id = "tagedit "..tostring(counter),
                notifier = function(text) 
                             
                             if g_selected_page == 1 then
                               renoise.app():show_message("Can't edt tag names on NATIVE page.\nOnly user pages")
                               return
                             end
                             
                             --truncate text to match button width
                             text = string.sub(text,1,13)
                           
                             --get the index for corresponding  tag buttons in the main gui
                             local tag_idx = tostring("tag "..counter)
                             --here we change the text of the corresponding tag buttons in main gui
                             vb.views[tag_idx].text = text 
                             
                             
                             
                             --fx page node
                             local fx_pages = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
                             
                             --change the xml entries
                             --the xml tags are: <page2> <tag_names>
                             --get the page tag string
                            
                            -- local page = tostring("page"..g_selected_page)
                            
                             --overwrite previous entry from global object
                             fx_pages[g_selected_page].tags[counter].name.value = text
                             
                            -- g_retrieved_xml[page].tag_names:remove(counter)
                             --add new entry where old one was
                            -- g_retrieved_xml[page].tag_names:insert(counter,text)
                             
                             --save the changed global object to xml
                             --------------------------------------
                             --get xml bundle path and concatenate the file name
                             local file_name = renoise.tool().bundle_path .. "saved_tags.xml" 
                             --save global document object to xml
                             g_retrieved_xml:save_as(file_name)

                           end  
               }

    --add each iteration into my_first_row
    if counter < 7 then 
      tags_col:add_child(tags) 
    else 
      tags_col_2:add_child(tags)
    end
  end --end loop
  ---------------------------------------
  
  --build dialog content
  local dialog_content = vb1:column{
                          margin = 4,
                          vb1:row{
                            vb1:text{
                              width = 232,
                            },
                            vb1:button{
                             text = "USER 1",
                             width = 25,
                             height = 22,
                             id = "vb1 button1",
                             color = COLOR_YELLOW_MILD,
                             notifier = function()
                                          --update button colors to show page selection
                                          vb1.views["vb1 button1"].color = COLOR_YELLOW_MILD
                                          vb1.views["vb1 button2"].color = COLOR_GREY
                                          --use above local function to change selection in main gui
                                          choose_page_in_main_gui(2)
                                          --update all textfields
                                          local tag_names = get_all_tag_names(2)
                                          for i = 1,12 do
                                            vb1.views["tagedit "..i].text =tostring(tag_names[i])
                                          end
                                          
                                          update_load_popup()
                                          
                                        end
                            },
                            vb1:button{
                              text = "USER 2",
                              width = 25,
                              height = 22,
                              id = "vb1 button2",
                              color = COLOR_GREY,
                                notifier = function()
                                          --update button colors to show page selection
                                          vb1.views["vb1 button1"].color = COLOR_GREY 
                                          vb1.views["vb1 button2"].color = COLOR_YELLOW_MILD
                                          --use above local function to change selection in main gui
                                          choose_page_in_main_gui(3)
                                          --update all textfields
                                          local tag_names = get_all_tag_names(3)
                                          for i = 1,12 do
                                            vb1.views["tagedit "..i].text =tostring(tag_names[i])
                                          end
                                          
                                          update_load_popup()
                                        end
                            },
                           },--vb1 row
                         --[[
                          vb1:textfield{
                            text = "User 1", 
                            width = 140,
                            height = 30,
                            notifier = function(text)
                                         local page = tostring("page"..g_selected_page)
                                         vb.views[page].text = text:upper()
                                       end,
                           
                          },--]]
                          vb1:text{
                            text = "   Tag Names:",
                            
                          },
                          --add in tags column
                          vb1:column{
                            margin = 4,
                            vb:row{
                            margin = 2,
                             tags_col,
                             },
                            vb:row{
                            margin = 2,
                             tags_col_2,
                            },
                           },
                          }
                          
  -------------------------------------------  
  
  local tag_names = nil
  --set chosen button to correct colors depending on global selected page variable
  if g_selected_page == 2 then
    vb1.views["vb1 button1"].color = COLOR_YELLOW_MILD
    vb1.views["vb1 button2"].color = COLOR_GREY
    tag_names = get_all_tag_names(2)
  elseif g_selected_page == 3 then
    vb1.views["vb1 button1"].color = COLOR_GREY 
    vb1.views["vb1 button2"].color = COLOR_YELLOW_MILD
    tag_names = get_all_tag_names(3)
  end
  --update tag text filds
  if tag_names ~= nil then 
    for i = 1,12 do
      vb1.views["tagedit "..i].text =tostring(tag_names[i])
    end
  end
  
  

  
  --Show script dialog
  my_vb1_dialog = renoise.app():show_custom_dialog(
      "Edit Tag Names", dialog_content)


end
