--Quick REF:

--1) Basic format of g_retrieved_xml object:
--------------------------------------------
--g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value


-----------
--tool name
-----------
TOOL_NAME = "Tagged Plugin Search"

----------------------------
--include other script files
----------------------------
--function files
require "fns_create_save_file"
require "fns_add_delete_load_save"
--require "fns_sort"
--secondary guis
require "gui_add_delete_load_save"
require "gui_edit_tag_names"



---------
--globals
---------
--global: index of the currently selected tag/button in the GUI
g_selected_button = 1
--global: index of the selected page
g_selected_page = 1
--global: will be document object to hold data from saved xml file
g_retrieved_xml = nil
--number of pages includinf Native,Page 1 and Page 2 (May expand later so user can add more tags)
g_num_pages = 3

--global 'root' holds the whole ducument/ i.e. the base node
root = nil

--used in Random Button  "R" 
local r_popup_items = {}


------------------------------

--keybind (4)
 renoise.tool():add_keybinding {
  name = "Global:Tools:"..TOOL_NAME,
  invoke = function()main_toggle()end  
}

renoise.tool():add_menu_entry {
  name = "DSP Device:"..TOOL_NAME,
  invoke = function()main_start()end      
}

--constants for clarity when passing to functions
--fil name
SAVED_TAGS_XML = "saved_tags.xml"

TYPE_INSTRUMENT = 1
TYPE_EFFECT = 2
---
PAGE_1 = 1
PAGE_2 = 2
PAGE_3 = 3
---
TAG_1 = 1
TAG_2 = 2
TAG_3 = 3
TAG_4 = 4
TAG_5 = 5
TAG_6 = 6
TAG_7 = 7
TAG_8 = 8
TAG_9 = 9
TAG_10 = 10
TAG_11 = 11
TAG_12 = 12
---
NUL = "nul"
---

--saves gui selection state
------------------------------------------
--Set up Preferences file
------------------------------------------
--create xml
local options = renoise.Document.create {
  selected_page = 1,
  selected_button = 1,
  selected_popup_idx = 1,
}
 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
------------------------------------------
--variable syntax 
--options.value_a.value

------------------
--for main() GUI
-----------------
--global viewbuilder object for main() gui (called in other files)
vb = nil
--my dialog local
local my_dialog = nil 

my_vb1_dialog = nil
vb1 = nil

my_vb2_dialog = nil
vb2 = nil

--------------------------------------------------------------------------------
--some basic colors for gui elements
--------------------------------------------------------------------------------
--e.g. For changing vb.views["sample present colour 2"].color when states change
COLOR_GREY = {0x30,0x42,0x42}
COLOR_ORANGE ={0xFF,0x66,0x00}
COLOR_YELLOW = {0xE0,0xE0,0x00}
COLOR_YELLOW_MILD = {0xE0,0xE0,0x88}
COLOR_BLUE = {0x50,0x40,0xE0}  
COLOR_RED = {0xEE,0x10,0x10}
COLOR_GREEN = {0x20,0x99,0x20}
COLOR_GREEN_MILD = {0xA8,0xEE,0xAB}
COLOR_RED_MILD = {0x90,0x10,0x10}

--Constants holding first index of color-code: Used to identify color in vb.views table i.e.
--if vb.views["button"].color[1] == COLOR_ORANGE_FLAG then --etc
COLOR_GREY_FLAG = COLOR_GREY[1]
COLOR_ORANGE_FLAG = COLOR_ORANGE[1]
COLOR_YELLOW_FLAG = COLOR_YELLOW[1]
COLOR_YELLOW_MILD_FLAG = COLOR_YELLOW_MILD[1]
COLOR_BLUE_FLAG = COLOR_BLUE[1]  
COLOR_RED_FLAG = COLOR_RED[1]
COLOR_GREEN_FLAG = COLOR_GREEN[1]
COLOR_RED_MILD_FLAG = COLOR_RED_MILD[1]


LUA_COUNTS_FROM_1 = 1


--------------------------------------------------------------------------------
--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
function status(message)
  renoise.app():show_status("Tagged Plugins Tool: ("..message..")")
end

---------------------------------------------------------------------
--helper function : custom app message --can be used instead of print 
---------------------------------------------------------------------
function msg(message)
  message = tostring(message)
  renoise.app():show_message(message)
end

--------------------------------------------------------------
--toggle the tool open and closed (keyboard shortcut start-up)
--------------------------------------------------------------
function main_toggle()
----------------------
 --close any open
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
    my_dialog = nil 
   if (my_vb1_dialog and my_vb1_dialog.visible) then 
     my_vb1_dialog:close()
   end
   --nil the objects
   my_vb1_dialog = nil
   vb1 = nil
   --secondary dialog 2 
   -- edit_tag_names_gui.lua
   if (my_vb2_dialog and my_vb2_dialog.visible) then 
    my_vb2_dialog:close()
   end 
   my_vb2_dialog = nil
   vb2 = nil 
   --un_added/tagged plugins
   if (my_vb3_dialog and my_vb3_dialog.visible) then
     my_vb3_dialog:close()
   end
     my_vb3_dialog = nil
     vb3 = nil
  else --run main
    main()
  end
end
-------------------------------------------------
--always open/ restart tool (menu entry start-up)
-------------------------------------------------
function main_start()
---------------------
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    --reset global my_dialog
     my_dialog = nil 
  end
  --run main
  main()
end
---


--function retrieves data from the file 'saved_tags.xml' and loads into object which is returned.
--If no xml found the default one is created.
--run on tool start-up.
----------------------------------
function load_data_from_xml_file()
---------------------------------
  --create document object/template
  local doc_root = create_document()
  --retrieve xml
  local file_path = renoise.tool().bundle_path..SAVED_TAGS_XML
  --check file exists
  local file = io.open(file_path,"r")--read
  --if file exists then retrieve:
  -------------------------------
  if file ~= nil then
    --close file that we just opened
    io.close(file) 
    --load file into doc
    doc_root:load_from(file_path)
    -- return retrieved_doc
    return doc_root
  --else no file found so create and save default xml.
  ----------------------------------------------------
  else 
    --add native renoise fx devices (needs to be called after doc created)
    popuplate_page_one_of_xml_with_default_renoise_devices()
    --save default document as an xml in the xrnx folder with the name saved_tags.xml
    doc_root:save_as(file_path)
    return doc_root
  end
end


--save global-object to xml (save file)
--used regularly, when updating lists/ saving plugs to tags etc.
----------------------------
function save_to_xml_file()
----------------------------
  --get xml bundle path and concatenate the file name
  local file_path = renoise.tool().bundle_path..SAVED_TAGS_XML
  --save global document object to xml
  g_retrieved_xml:save_as(file_path)  
end


----------------------------
function save_to_xml_file()
----------------------------
  --get xml bundle path and concatenate the file name
  local file_path = renoise.tool().bundle_path..SAVED_TAGS_XML
  --save global document object to xml
  g_retrieved_xml:save_as(file_path)  
end





--insert a new plug to root doc object 
--example parameters: (TYPE_EFFECT,PAGE_1,TAG_1,"Compressor","Audio/Effects/Native/Compressor")  (string,int,int,string,string)
---------------------------------------------------------
function insert_new_plugin_node(type,page,tag,name,path)
---------------------------------------------------------
  --get the instrument or fx branch of the root document
  if type == 1 or type == 2 then
    type = root.plugin_types[type]
  else
    error("No Correct Type Specified")
  end

  local tag_idx = tag
  --get tag path in document
  local tag = type.pages[page].tags[tag]
  
  --check if node was already added and return with status if it has
  for i = 1,#tag.plugs,1 do
    --compare paths
    if path == tag.plugs[i].plug_path.value then
      name = tostring(tag.plugs[i].plug_name.value)
      status("plug: "..name.."\nwith Path: "..path.."\nwas already added to tag:"..tag_idx.."\n")
      return
    end
  end
  
  --instantiate a new plugin node
  local new_plugin = renoise.Document.instantiate("Plugin")
   
  --insert the node
  local test = tag.plugs:insert(new_plugin) --?? does this return the same as plug below?
  --get last (just added) plug node position
  local plug = tag.plugs[#tag.plugs]
  --print(rawequal(test,plug)) returns false????
  
  --add new plugs name and path values into plug node
  plug.plug_name.value = name
  plug.plug_path.value = path
  --return plug node
  return plug
end


--remove a plug from doc example parameters: (TYPE_EFFECT,PAGE_1,TAG_1,"Compressor")  (string,int,int,string)
--NOTE Does not save doc as would be ineffient in loops
------------------------------------------------
function remove_plugin_node(type,page,tag,name) --(TYPE_EFFECT,PAGE_1,TAG_1,"Compressor")
------------------------------------------------

  --get the instrument or fx branch of the root document
   if type == 1 or type == 2 then
    type = root.plugin_types[type]
  else
    error("No Correct Type Specified")
  end
  
  --plug list
  local plugs = type.pages[page].tags[tag].plugs  
    
  --check entry exists
  if plugs[1].plug_name == nil then
    error("ERROR No Plug Entries To Remove")
    return
  end
  
  --loop plug list to match name
  for i = 1,#plugs do
    if plugs[i].plug_name.value == name then
     --remove from list
     plugs:remove(i)
     return name.." was removed from document"
    end
  end
  return name.." not found for removal"
end




--update [LOAD]-button Popup, to match selected page and tag
-----------------------
function update_load_popup()
-----------------------
  --Basic format of g_retrieved_xml object:
  --g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value
  ----------------------------------------------------------------------------------
  --table to hold plug names.
  local new_items = {}
  --loop xml object to populate table
  local selected_tag = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[g_selected_page].tags[g_selected_button]
  for i = 1,#selected_tag.plugs do
    table.insert(new_items,tostring(selected_tag.plugs[i].plug_name.value))
  end
  --[[
  --add indexes
  
  for i = 1,#new_items do
    new_items[i] = i..".  "..new_items[i]
  end
  --]] 
  
  --add table of devices to popup
  vb.views["load plug popup"].items = new_items   
end


--UPDATE PAGE FN
--UPDATE BUTTON NAMES
--UPDATE POPUP
--refreshes the selected page in the gui
--------------------------
function gui_refresh_page()
---------------------------
  --get page tag from global
 --------------------------
  --set selected page (turn button yellow) from g_selected_page --value has been loaded from prefs
  local first_page = "page"..tostring(g_selected_page) 
  vb.views[first_page].color = COLOR_YELLOW_MILD
  
  --update tag buttons
  --------------------
  for button = 1,12 do
    --get each tag names for page 1 from the xml 
    local tag = tostring(g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[g_selected_page].tags[button].name.value)
    vb.views["tag "..tostring(button)].text = tag
  end
 
  --show/hide edit buttons (tags/names) so not available if page 1 NATIVE
  -------------------------------------
  if g_selected_page == 1 then
    vb.views["editnames"].active = false
    vb.views["edittags"].active = false
  else
    vb.views["editnames"].active = true
    vb.views["edittags"].active = true
  end
 
  --call update_popup fn
  ----------------------
  update_load_popup()
 
  --restore the last selected popup item if possible/valid
  if #vb.views["load plug popup"].items >= options.selected_popup_idx.value then
    vb.views["load plug popup"].value = options.selected_popup_idx.value
  end
end
---


------------------------------------
------------------------------------
function main()
------------------------------------
    
  --toggle dialog so if its already open then close it.  The timer will catch
  --that it is closed and do the housekeeping like removing notifiers (and timer itself)
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
    return
  end
  
  --renoise song object
  local song = renoise.song()

  --set globals
  -------------
  --assign global vb to viewbuilder
  vb = renoise.ViewBuilder()
  --set flag used for renameing textfield
  local bypass_rename = false
  
  r_popup_items = {}
  
  --make global 'g_retrieved_xml' our default document object
  -----------------------------------------------------------
  g_retrieved_xml = load_data_from_xml_file()
  --get the selected page (index) from the loaded xml data
 -- g_selected_page = tonumber(g_retrieved_xml.selected_page.value)
  

  --update globals from options (tools preferences xml file)
  g_selected_button = options.selected_button.value --round as options saves as float
  g_selected_page = options.selected_page.value
 
 -- g_selected_button = 1
 -- g_selected_page = 1

  ----------------------------------------------
  --GUI
  ----------------------------------------------  
  
  --table to text
  --here we take the global tag_table which links all the tags with the
  --plugins (CURRENTLY ONLY NATIVE) and get all the plug names

 -- oprint(#g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[1].tags)
  
  -----------------------------------
  local function get_all_tag_names()
  -----------------------------------
    local tag_names_table = {}
    
     local fx_node = g_retrieved_xml.plugin_types[TYPE_EFFECT]
    --loop
    for tag = 1,#fx_node.pages[1].tags do --format plugin_types[].pages[].tags[].plugs[].plug_path.value
      tag_names_table[tag] = tostring(fx_node.pages[1].tags[tag].name.value) --use tostring as we are reading string doc objects
    end
    return tag_names_table
  end
  -----------------------------------
  --run
  local tag_name_table = get_all_tag_names()
  local tag_count = #tag_name_table

 
  --CONTENT
  ----------------
  --function called by tag buttons
  --------------------------------------
  local function button_function(tag_index)
  --------------------------------------
    --update selected button()
    g_selected_button = tag_index
    --update options
    options.selected_button.value = tag_index
    
   -- print(options.selected_button.value)
    
    local names = ""
    --counter to display number of each plugin
    local idx = 1
    --clear all button colors to grey
    for i = 1, tag_count do
      --all to grey
      vb.views["tag "..tostring(i)].color = COLOR_GREY
    end
    --make this button(selected) orange
    vb.views["tag "..tostring(tag_index)].color = COLOR_ORANGE
    --update popup where plug will be loaded from
    update_load_popup()
    --set popup vale to 1
    vb.views["load plug popup"].value = 1
  end
  
  --------------------------------------
  local top_row_b_width = 130
  local top_row_b_height = 28
  local my_first_row = vb:row {
                        margin = 4,
                        --style = "group",
                         vb:button{
                          width = top_row_b_width,
                          height = top_row_b_height,
                          color = COLOR_GREY,
                          id = "page1",
                          text = "NATIVE",
                          notifier = function()
                                       --update global to reflect the selected page
                                       g_selected_page = 1
                                       --rest global for random button
                                       r_popup_items = {}
                                       
                                       --update page button colors
                                       vb.views["page1"].color = COLOR_YELLOW_MILD
                                       vb.views["page2"].color = COLOR_GREY
                                       vb.views["page3"].color = COLOR_GREY
                                       
                                       --update tag buttons and popup
                                       for button = 1,12 do
                                         --get each tag names for page 1 from the xml 
                                         local tag = tostring(g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[PAGE_1].tags[button].name.value)
                                         --update button
                                         vb.views["tag "..tostring(button)].text = tag
                                       end
                                       
                                       --set the selected page to "1" in the global object and then save xml
                                       options.selected_page.value = 1
                                       save_to_xml_file()
                                       
                                       --update Popup to match selected page and tag
                                       ----------------------------------------------
                                       update_load_popup()
                                       --set popup vale to 1
                                       vb.views["load plug popup"].value = 1
                                       --update options
                                       options.selected_page.value = 1
                                       
                                       --make edit buttons invisible as not available for NATIVE
                                       vb.views["editnames"].active = false
                                       vb.views["edittags"].active = false
                                       --make edit page add/delete buttons inactive in case edit page is open
                                       if vb2 ~= nil then
                                         vb2.views["vb2b1"].active = false
                                         vb2.views["vb2b2"].active = false
                                         vb2.views["vb2b3"].active = false
                                         vb2.views["vb2b4"].active = false
                                         vb2.views["vb2b5"].active = false
                                         vb2.views["vb2b6"].active = false
                                       end
                                     end,
                          
                         },
                         
                         vb:button{
                          width = top_row_b_width,
                          height = top_row_b_height,
                          text = "USER 1",
                          color = COLOR_GREY,
                          id = "page2",
                          notifier = function()
                                       --update global to reflect the selected page
                                       g_selected_page = 2
                                       --reset globals for random button
                                       r_popup_items = {}
                                       --update page button colors
                                       vb.views["page1"].color = COLOR_GREY
                                       vb.views["page2"].color = COLOR_YELLOW_MILD
                                       vb.views["page3"].color = COLOR_GREY
                                       
                                       --update tag buttons and popup
                                       for button = 1,12 do
                                          --get each tag names for page 1 from the xml 
                                         -- local tag = tostring(g_retrieved_xml.page2.tag_names[button])
                                          local tag = tostring(g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[PAGE_2].tags[button].name.value)
                                          vb.views["tag "..tostring(button)].text = tag
                                       end
                                       
                                       --set the selected page in the global object and then save xml
                                       options.selected_page.value = 2
                                      
                                       save_to_xml_file()
                                       
                                       --update popup items
                                       ---------------------
                                       update_load_popup()
                                       --update options
                                       --set popup vale to 1
                                       vb.views["load plug popup"].value = 1
                                       options.selected_page.value = 2
                                       
                                       --make edit buttons visible
                                       vb.views["editnames"].active = true
                                       vb.views["edittags"].active = true
                                       --make edit page add/delete buttons active in case edit page is open
                                       if vb2 ~= nil then
                                         vb2.views["vb2b1"].active = true
                                         vb2.views["vb2b2"].active = true
                                         vb2.views["vb2b3"].active = true
                                         vb2.views["vb2b4"].active = true
                                         vb2.views["vb2b5"].active = true
                                         vb2.views["vb2b6"].active = true
                                       end
                                     end,
                         },
                         
                         vb:button{
                          width = top_row_b_width,
                          height = top_row_b_height,
                          text = "USER 2",
                          color = COLOR_GREY,
                          id = "page3",
                          notifier = function()
                                       --update global to reflect the selected page
                                       g_selected_page = 3
                                       --reset globals for random button
                                       r_popup_items = {}
                                       --update page button colors
                                       vb.views["page1"].color = COLOR_GREY
                                       vb.views["page2"].color = COLOR_GREY
                                       vb.views["page3"].color = COLOR_YELLOW_MILD
                                       
                                        --update tag buttons and popup
                                       for button = 1,12 do
                                          --get each tag names for page 1 from the xml
                                         -- local tag = tostring(g_retrieved_xml.page3.tag_names[button])
                                          local tag = tostring(g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[PAGE_3].tags[button].name.value)
                                          vb.views["tag "..tostring(button)].text = tag
                                       end
                                       
                                       --set the selected page in the global object and then save xml
                                       options.selected_page.value = 3
                                       save_to_xml_file()
                                       
                                       --update Popup to match selected page and tag
                                       ----------------------------------------------
                                       update_load_popup()
                                       --set popup vale to 1
                                       vb.views["load plug popup"].value = 1
                                       --update options
                                       options.selected_page.value = 3
                                       
                                       --make edit buttons visible
                                       vb.views["editnames"].active= true
                                       vb.views["edittags"].active = true
                                       --make edit page add/delete buttons active in case edit page is open
                                       if vb2 ~= nil then
                                         vb2.views["vb2b1"].active = true
                                         vb2.views["vb2b2"].active = true
                                         vb2.views["vb2b3"].active = true
                                         vb2.views["vb2b4"].active = true
                                         vb2.views["vb2b5"].active = true
                                         vb2.views["vb2b6"].active = true
                                       end
                                     end,
                         },
                         vb:text{ 
                          width = 80,
                        
                        },
                        vb:button{
                         color = COLOR_GREY,
                         text = "Edit Names", --BUTTON
                         id = "editnames",
                         notifier = function()
                                    --show secondary gui (defined in 'required' file edit_tag_names.lua)
                                      edit_tag_names_gui(vb)                                                                         
                                     end
                          },
                        }
  
  
  --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_second_row = vb:row {margin = 4}
  -------------------------------
  local my_second_element = nil
  
   --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_third_row = vb:row {margin = 4}
  -------------------------------
  local my_third_element = nil
  
  
  local TAG_HEIGHT = 24
  --loop to create >> TAG BUTTONS << and add them to my_first_row
  for button = 1, 6 do
    --1 button
    my_second_element = vb:button { 
                        width = 90,
                        height = TAG_HEIGHT,
                        text = tag_name_table[button],
                        color = COLOR_GREY,
                        id = "tag "..tostring(button),
                        notifier = function() button_function(button)
                                              --reset globals for random button
                                               r_popup_items = {}
                                              end --enclose in 'shell' fn so we can pass variable (button)  
                       }

    --add each iteration into my_first_row
    my_second_row:add_child(my_second_element) 
  end --end loop
  -----------------------
  
    
  --loop to create second row of >> TAG BUTTONS << and add them to my_first_row
  for button = 7, tag_count do
    --1 button
    my_third_element = vb:button { 
                         width = 90,
                         height = TAG_HEIGHT,
                         color = COLOR_GREY,
                         text = tag_name_table[button],
                         id = "tag "..tostring(button),
                         notifier = function() button_function(button)
                                               --rest globals for random button 
                                               r_popup_items = {}
                                               
                                               end --enclose in 'shell' fn so we can pass variable (button)  
                       }

    --add each iteration into my_first_row
    my_third_row:add_child(my_third_element) 
  end --end loop
  -----------------------
  
 
 
 
 
 
 
 
 
  local my_fourth_row = vb:row {
                         margin = 4,
                          --vb:multiline_textfield{
                          --id = "ml text",
                          -- width = 250,
                          -- height = 300,
                        --  },
                          vb:popup{
                           width = 200,
                           height = 30,
                           id = "load plug popup",
                           notifier = function(index)
                                         options.selected_popup_idx.value = index
                                         
                                      end 
                          
                          },
                          vb:text{
                           width = 3,
                          },
                          vb:button{
                           id = "rbutton",
                           text = "R",
                           color = COLOR_GREY,
                           height = 30,
                           notifier = function() --select a random item in the selected-tag load popup
                                       
                                        --To select random items in the popup, we use a simple table [r_popup_items] that stores potential indexes to be picked. 
                                        --r_popup_items has consecutive entries { [1] = 1, [2] = 2, [3] = 3, [4] = 4, etc..} up to the num of plugin items in the popup.
                                        --We choose a random index using Luas math.random() function, Upper limit set to size of r_popup_items.
                                        --Once we have used an entry e.g entry [3] we discard it using lua's table.remove() function. e.g. when 3 has been removed the items become
                                        --{ [1] = 1, [2] = 2, [3] = 4, [4] = 5, etc..}
                                        --The value for 3 has now become 4 and the value for 4 has become 5.
                                        --Once the table r_popup_items has become depleted we repopulate it and start again.  The table is global and it will be reset when a different tag becomes chosen by the user.
                                       
                                        --number of devices in this tag                                        
                                        local num_available_devs = #vb.views["load plug popup"].items
                                        
                                        --when not enough items in the popup return
                                        if num_available_devs < 2 then
                                          status("Not enough entries to shuffle")
                                          return
                                        end
                                        
                                        --if index table has been emptied or it is the first run on this tag, re-populate it
                                        if #r_popup_items == 0 then
                                          for i = 1,num_available_devs do
                                            --a simple table where { [1] = 1, [2] = 2, [3] = 3 etc..}
                                            r_popup_items[i] = i
                                          end
                                         -- print("\n")
                                        end
                                          
                                        --random number
                                        ---------------
                                        --get os.time() as a seed
                                        local t = os.time()
                                        --as os.time() updates slowly we multiply it by random number before passing to randomseed
                                        math.randomseed((t * math.random(1,789)))
                                        --get random number based on os.time()
                                        local ran_num = nil
                                        --make sure random number doesn't choose current item (can happen between cycles).  We already made sure above that 
                                        --at least 2 items are in the popup
                                        while 1 do
                                          --random number between 1 and the length of the index-storing table
                                          ran_num = math.random(1, #r_popup_items)
                                          --break when we know it won't choose the same as current popup value
                                          if r_popup_items[ran_num] ~= vb.views["load plug popup"].value then
                                            break
                                          end
                                        end

                                        --set popup to random value
                                        ---------------------------
                                        local rand_index = r_popup_items[ran_num]
                                        vb.views["load plug popup"].value = rand_index
                                        --print(vb.views["load plug popup"].items[vb.views["load plug popup"].value])
                                        
                                        --discard index value/ entry from our simple index table r_popup_items.  The used 'index value' can not be selected again.
                                        table.remove(r_popup_items ,ran_num)
                                        --calculate the 'hit' number of the "R" 'random' button by the user, from the size of the shrinking index table
                                        local hit = num_available_devs - #r_popup_items
                                        --update status
                                        status(" Plug "..rand_index.." / "..num_available_devs.."      Hit: "..hit)
                                      end
                          
                          }
  
                         }
  -------------------------------
  
  local my_fifth_row = vb:row {
                        margin = 4,
                        vb:button{
                          text = "LOAD",
                          width = 200,
                          color = COLOR_GREY,
                          height = 30,
                          notifier = function()
                                       
                                       --load fn
                                       ------------------------------------
                                       local function load_device(dev_path)
                                       ------------------------------------
                                         --song object
                                         local song = renoise.song()
                                         --selected track object
                                         local cur_track = song.selected_track
                                         --check device exists
                                         local infos = cur_track.available_device_infos
                                         --flag
                                         local device_missing = true
                                         --loop available devices
                                         for i = 1,#infos do
                                           if dev_path == infos[i].path then
                                             device_missing = false
                                             break
                                           end
                                         end
                                         
                                         if device_missing == true then
                                           renoise.app():show_message("Device Not Present In Renoise.\nIt May Need To Be Re-installed\nAnd Your Plugs Re-Scanned")
                                           return
                                         end
                                         
                                         --insert the device to either the sampler if open in middle view, else the main renoise track.
                                         local device = nil
                                         --insert to sampler
                                         if renoise.app().window.active_middle_frame == renoise.ApplicationWindow.MIDDLE_FRAME_INSTRUMENT_SAMPLE_EFFECTS then
                                           --sample_dev chain
                                           local chain = song.selected_sample_device_chain
                                           local insert_pos = (song.selected_sample_device_index) or (#chain.devices) --<-selected device can be nil
                                           --catch when no selected device results in 0
                                           if insert_pos == 0 then
                                             insert_pos = #chain.devices 
                                           end
                                           --increment so device adds after
                                           insert_pos = insert_pos + 1 
                                           --insert dev
                                           device = chain:insert_device_at(dev_path,insert_pos)
                                           --select new device
                                           song.selected_sample_device_index = insert_pos
                                           --open device gui
                                           if device.external_editor_available == true then
                                             device.external_editor_visible = true
                                           end
                                         else
                                           --insert pos at selected device or end of devices if none selected
                                           local insert_pos = (song.selected_track_device_index) or (#cur_track.devices) --<-selected device can be nil
                                           --catch when no selected device results in 0
                                           if insert_pos == 0 then
                                             insert_pos = #cur_track.devices 
                                           end
                                           --increment so device adds after
                                           insert_pos = insert_pos + 1 
                                           --insert device to main track/ mixer
                                           device = cur_track:insert_device_at(dev_path,insert_pos)
                                           --select device
                                           song.selected_device_index = insert_pos
                                           --open device gui
                                           if device.external_editor_available == true then
                                             device.external_editor_visible = true
                                           end
                                         end
                                       end--end local fn
                                       ------
                                       
                                       --get plug index from LOAD popup
                                       local plug_index = vb.views["load plug popup"].value 
                                       --check that the plug node in xml contains path entries.  If not then return status
                                       if #g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[g_selected_page].tags[g_selected_button].plugs == 0 then
                                         status("No Plug Present In Tag To Load")
                                         return
                                       end
                                       --get path from xml object
                                       local path = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[g_selected_page].tags[g_selected_button].plugs[plug_index].plug_path.value
                                       --turn document observable string into a standatd string
                                       path = tostring(path)
                                       --pass path string to above local function to load device.
                                       load_device(path)
                                     end,
                          }, 
                          
                         vb:text{ --spacer
                          width = 252,
                         },
                         
                         vb:button{
                          height = 20,
                          width = 80,
                          id = "edittags",
                          text = "Edit Tags",
                          color = COLOR_GREY,
                          notifier = function()
                                      --pass in vb (this viewbuilder) 
                                      --opens a new sub-gui
                                      load_and_save_gui(vb) --see add_delete_load_save_gui.lua
                                    end
                         
                         },
                              
                       } 

  
  
  
  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{}
  dialog_content:add_child(my_first_row)
  dialog_content:add_child(vb:row{vb:text {text = "---------------------------------------------------------------------------------------------------------------------------------------"}})
  dialog_content:add_child(my_second_row)
  dialog_content:add_child(my_third_row)
  dialog_content:add_child(my_fourth_row)
  dialog_content:add_child(my_fifth_row)
  
  
 
  
  --tool set up:
  --the page/button and popup entry are saved in options file so we can open the tool in the same state as it was left
  -----------------------------
  --select last selected button
  button_function(g_selected_button)--g_selected_button value has already been set from options pref file
  
  
  gui_refresh_page()
  
  --[[
  --Setup after GUI been built
  --------------------------
  --set selected page (turn button yellow) from g_selected_page --value has been loaded from prefs
  local first_page = "page"..tostring(g_selected_page) 
  vb.views[first_page].color = COLOR_YELLOW_MILD
  
  --update tag buttons
  --------------------
   for button = 1,12 do
      --get each tag names for page 1 from the xml 
      local tag = tostring(g_retrieved_xml[first_page].tag_names[button])
      vb.views["tag "..tostring(button)].text = tag
   end
   
   --show/hide edit buttons (tags/names) so not available if page 1 NATIVE
   -------------------------------------
   if g_selected_page == 1 then
     vb.views["editnames"].active = false
     vb.views["edittags"].active = false
   else
     vb.views["editnames"].active = true
     vb.views["edittags"].active = true
   end
   
   --call update_popup fn
   ----------------------
   update_load_popup()
      
   --restore the last selected popup item if possible/valid
   if #vb.views["load plug popup"].items >= options.selected_popup_idx.value then
     vb.views["load plug popup"].value = options.selected_popup_idx.value
   end
   
                                       
--]]
  
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
  ---------------------------------------------
  -- rprint(key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      TOOL_NAME, dialog_content,my_keyhandler_func)
      
      
 

 
  --add timer to fire once every 80ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end

  

  
  -- notifier to close dialog on load new song
  if renoise.tool().app_release_document_observable:has_notifier(closer) == false then
    renoise.tool().app_release_document_observable:add_notifier(closer)
  end
  -------------------------------------------------------------------------------
  
  --first run of timer
  -- timer()
end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------

------------------------------------    
--close dialog function ON NEW SONG / used in timer() aswell
------------------------------------
function closer()
-----------------
  --close dialog if exists and is open     
  if (my_dialog ~= nil) and (my_dialog.visible == true) then
    my_dialog:close()
  end

  --reset global my_dialog
  my_dialog = nil
  --close vb1 (secondary dialog) 
  --add_delete_load_save_gui.lua 
  if (my_vb1_dialog and my_vb1_dialog.visible) then 
    my_vb1_dialog:close()
  end
  --nil the objects
  my_vb1_dialog = nil
  vb1 = nil
  
  --secondary dialog 2 
  --edit_tag_names_gui.lua
  if (my_vb2_dialog and my_vb2_dialog.visible) then 
    my_vb2_dialog:close()
   end 
  --nil
  my_vb2_dialog = nil
  vb2 = nil 
  
  if (my_vb3_dialog and my_vb3_dialog.visible) then
    my_vb3_dialog:close()
  end
  --nil
  my_vb3_dialog = nil
  vb3 = nil
end
----

--timer closes open secondary windows when the main window closes
------------------------------------
function timer()
----------------

  --return as dialog open so no need to shut secondary windows   
  if (my_dialog ~= nil) and (my_dialog.visible == true) then
    return
  end
  
  --if here the main tool window has just been shut
  -------------------------------------------------
  --reset global my_dialog
  my_dialog = nil
  --close vb1 (secondary dialog) 
  --add_delete_load_save_gui.lua 
  if (my_vb1_dialog and my_vb1_dialog.visible) then 
    my_vb1_dialog:close()
  end
  --nil the objects
  my_vb1_dialog = nil
  vb1 = nil
  
  --secondary dialog 2 
  --edit_tag_names_gui.lua
  if (my_vb2_dialog and my_vb2_dialog.visible) then 
    my_vb2_dialog:close()
   end 
  --nil
  my_vb2_dialog = nil
  vb2 = nil 
  
  if (my_vb3_dialog and my_vb3_dialog.visible) then
    my_vb3_dialog:close()
  end
  --nil
  my_vb3_dialog = nil
  vb3 = nil
  
  --remove timer, it will be re-added next time tool opens
  if renoise.tool():has_timer(timer) == true then
    renoise.tool():remove_timer(timer)
  end
end
---











